#ifndef _CTYPE_H
#define _CTYPE_H

#define _U	0x01	/* upper */							// ñλڴдַ[A-Z]
#define _L	0x02	/* lower */							// ñλСдַ[a-z]
#define _D	0x04	/* digit */							// ñλֵ[0-9]
#define _C	0x08	/* cntrl */							// ñλڿַ
#define _P	0x10	/* punct */							// ñλڱַ
#define _S	0x20	/* white space (space/lf/tab) */	// հַո\t\nȡ
#define _X	0x40	/* hex digit */						// ñλʮ  
#define _SP	0x80	/* hard space (0x20) */				// ñλڿոַ0x20

extern unsigned char _ctype[];				// ַ飨ַӦԡ
extern char _ctmp;							// һʱַڶlib/cype.cУ

// һЩȷַ͵ĺ
#define isalnum(c) ((_ctype+1)[(int)c]&(_U|_L|_D))			// ַ [A-Z] [a-z][0-9]
#define isalpha(c) ((_ctype+1)[(int)c]&(_U|_L))				// ַ
#define iscntrl(c) ((_ctype+1)[(int)c]&(_C))				// ǿַ
#define isdigit(c) ((_ctype+1)[(int)c]&(_D))				// ֡
#define isgraph(c) ((_ctype+1)[(int)c]&(_P|_U|_L|_D))		// ͼַ
#define islower(c) ((_ctype+1)[(int)c]&(_L))				// Сдַ
#define isprint(c) ((_ctype+1)[(int)c]&(_P|_U|_L|_D|_SP))	// ǿɴӡַ
#define ispunct(c) ((_ctype+1)[(int)c]&(_P))				// Ǳš
#define isspace(c) ((_ctype+1)[(int)c]&(_S))				// ǿհַո,\f,\n,\r,\t,\v
#define isupper(c) ((_ctype+1)[(int)c]&(_U))				// Ǵдַ
#define isxdigit(c) ((_ctype+1)[(int)c]&(_D|_X))			// ʮ֡

// Уǰʹǰ׺unsignedcӦüţʾɣc
// ΪڳCһӵıʽ
#define isascii(c) (((unsigned) c)<=0x7f)					// ASCIIַ
#define toascii(c) (((unsigned) c)&0x7f)					// ת ASCIIַ

// 춨ʹһʱ_ctmpԭǣں궨УĲֻܱʹһΡ
// ڶ߳˵ǲȫģΪ߳̿ͬһʱʹʱ
// ˴Linux2.2.x汾ʼΪʹȡ궨.
#define tolower(c) (_ctmp=c,isupper(_ctmp)?_ctmp-('A'-'a'):_ctmp)		// תСдַ
#define toupper(c) (_ctmp=c,islower(_ctmp)?_ctmp-('a'-'A'):_ctmp)		// תɴдַ

#endif
